'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _defineProperty = require('@babel/runtime-corejs3/helpers/defineProperty');
var _objectWithoutProperties = require('@babel/runtime-corejs3/helpers/objectWithoutProperties');
require('@babel/runtime-corejs3/core-js-stable/array/is-array');
var _Object$keys = require('@babel/runtime-corejs3/core-js-stable/object/keys');
var _Object$getOwnPropertySymbols = require('@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols');
var _filterInstanceProperty = require('@babel/runtime-corejs3/core-js-stable/instance/filter');
var _Object$getOwnPropertyDescriptor = require('@babel/runtime-corejs3/core-js-stable/object/get-own-property-descriptor');
var _forEachInstanceProperty = require('@babel/runtime-corejs3/core-js-stable/instance/for-each');
var _Object$getOwnPropertyDescriptors = require('@babel/runtime-corejs3/core-js-stable/object/get-own-property-descriptors');
var _Object$defineProperties = require('@babel/runtime-corejs3/core-js-stable/object/define-properties');
var _Object$defineProperty = require('@babel/runtime-corejs3/core-js-stable/object/define-property');
var reactIntl = require('react-intl');
var isEmpty = require('lodash/isEmpty');
var reactSelect = require('react-select');
var AsyncCreatableSelect = require('react-select/async-creatable');
var Constraints = require('@commercetools-uikit/constraints');
var LoadingSpinner = require('@commercetools-uikit/loading-spinner');
var selectUtils = require('@commercetools-uikit/select-utils');
var utils = require('@commercetools-uikit/utils');
var jsxRuntime = require('@emotion/react/jsx-runtime');

function _interopDefault (e) { return e && e.__esModule ? e : { 'default': e }; }

var _Object$keys__default = /*#__PURE__*/_interopDefault(_Object$keys);
var _Object$getOwnPropertySymbols__default = /*#__PURE__*/_interopDefault(_Object$getOwnPropertySymbols);
var _filterInstanceProperty__default = /*#__PURE__*/_interopDefault(_filterInstanceProperty);
var _Object$getOwnPropertyDescriptor__default = /*#__PURE__*/_interopDefault(_Object$getOwnPropertyDescriptor);
var _forEachInstanceProperty__default = /*#__PURE__*/_interopDefault(_forEachInstanceProperty);
var _Object$getOwnPropertyDescriptors__default = /*#__PURE__*/_interopDefault(_Object$getOwnPropertyDescriptors);
var _Object$defineProperties__default = /*#__PURE__*/_interopDefault(_Object$defineProperties);
var _Object$defineProperty__default = /*#__PURE__*/_interopDefault(_Object$defineProperty);
var isEmpty__default = /*#__PURE__*/_interopDefault(isEmpty);
var AsyncCreatableSelect__default = /*#__PURE__*/_interopDefault(AsyncCreatableSelect);
var Constraints__default = /*#__PURE__*/_interopDefault(Constraints);
var LoadingSpinner__default = /*#__PURE__*/_interopDefault(LoadingSpinner);

const _excluded = ["value", "isSearchable", "menuPortalZIndex"];
function ownKeys(e, r) { var t = _Object$keys__default["default"](e); if (_Object$getOwnPropertySymbols__default["default"]) { var o = _Object$getOwnPropertySymbols__default["default"](e); r && (o = _filterInstanceProperty__default["default"](o).call(o, function (r) { return _Object$getOwnPropertyDescriptor__default["default"](e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var _context, _context2; var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? _forEachInstanceProperty__default["default"](_context = ownKeys(Object(t), !0)).call(_context, function (r) { _defineProperty(e, r, t[r]); }) : _Object$getOwnPropertyDescriptors__default["default"] ? _Object$defineProperties__default["default"](e, _Object$getOwnPropertyDescriptors__default["default"](t)) : _forEachInstanceProperty__default["default"](_context2 = ownKeys(Object(t))).call(_context2, function (r) { _Object$defineProperty__default["default"](e, r, _Object$getOwnPropertyDescriptor__default["default"](t, r)); }); } return e; }
const LoadingIndicator = () => jsxRuntime.jsx(LoadingSpinner__default["default"], {
  scale: "s"
});
LoadingIndicator.displayName = 'LoadingIndicator';
const customizedComponents = {
  DropdownIndicator: selectUtils.DropdownIndicator,
  ClearIndicator: selectUtils.ClearIndicator,
  LoadingIndicator,
  MultiValueRemove: selectUtils.TagRemove
};
const AsyncCreatableSelectInput = _ref => {
  let _ref$value = _ref.value,
    value = _ref$value === void 0 ? null : _ref$value,
    _ref$isSearchable = _ref.isSearchable,
    isSearchable = _ref$isSearchable === void 0 ? true : _ref$isSearchable,
    _ref$menuPortalZIndex = _ref.menuPortalZIndex,
    menuPortalZIndex = _ref$menuPortalZIndex === void 0 ? 1 : _ref$menuPortalZIndex,
    props = _objectWithoutProperties(_ref, _excluded);
  const intl = reactIntl.useIntl();
  const placeholder = props.placeholder || intl.formatMessage(selectUtils.messages.placeholder);
  if (!props.isReadOnly) ;
  if (props.isMulti) ;
  selectUtils.warnIfMenuPortalPropsAreMissing({
    menuPortalZIndex: menuPortalZIndex,
    menuPortalTarget: props.menuPortalTarget,
    componentName: 'AsyncCreatableSelectInput'
  });
  return jsxRuntime.jsx(Constraints__default["default"].Horizontal, {
    max: props.horizontalConstraint,
    children: jsxRuntime.jsx("div", _objectSpread(_objectSpread({}, utils.filterDataAttributes(_objectSpread({
      value,
      isSearchable,
      menuPortalZIndex
    }, props))), {}, {
      children: jsxRuntime.jsx(AsyncCreatableSelect__default["default"], {
        "aria-label": props['aria-label'],
        "aria-labelledby": props['aria-labelledby'],
        "aria-invalid": props['aria-invalid'],
        "aria-errormessage": props['aria-errormessage'],
        autoFocus: props.isAutofocussed,
        backspaceRemovesValue: props.isReadOnly ? false : props.backspaceRemovesValue,
        components: _objectSpread(_objectSpread(_objectSpread(_objectSpread({}, customizedComponents), props.iconLeft && !props.isMulti ? selectUtils.customComponentsWithIcons : {}), props.isReadOnly ? {
          Input: ownProps => jsxRuntime.jsx(reactSelect.components.Input, _objectSpread(_objectSpread({}, ownProps), {}, {
            readOnly: true
          }))
        } : {}), props.components),
        menuIsOpen: props.isReadOnly ? false : undefined,
        styles: selectUtils.createSelectStyles({
          hasWarning: props.hasWarning,
          hasError: props.hasError,
          showOptionGroupDivider: props.showOptionGroupDivider,
          menuPortalZIndex: menuPortalZIndex,
          isCondensed: props.isCondensed,
          isDisabled: props.isDisabled,
          isReadOnly: props.isReadOnly,
          iconLeft: props.iconLeft,
          isMulti: props.isMulti,
          hasValue: !isEmpty__default["default"](value),
          horizontalConstraint: props.horizontalConstraint
        }),
        filterOption: props.filterOption
        // react-select uses "id" (for the container) and "inputId" (for the input),
        // but we use "id" (for the input) and "containerId" (for the container)
        // instead.
        // This makes it easier to less confusing to use with <label />s.
        ,
        id: props.containerId,
        inputId: props.id,
        inputValue: props.inputValue,
        isClearable: props.isReadOnly ? false : props.isClearable,
        isDisabled: props.isDisabled,
        isOptionDisabled: props.isOptionDisabled,
        isMulti: props.isMulti,
        isSearchable: isSearchable,
        maxMenuHeight: props.maxMenuHeight,
        menuPortalTarget: props.menuPortalTarget,
        menuShouldBlockScroll: props.menuShouldBlockScroll,
        closeMenuOnScroll: props.closeMenuOnSelect,
        name: props.name,
        noOptionsMessage: props.noOptionsMessage || (_ref2 => {
          let inputValue = _ref2.inputValue;
          return inputValue === '' ? intl.formatMessage(selectUtils.messages.noOptionsMessageWithoutInputValue) : intl.formatMessage(selectUtils.messages.noOptionsMessageWithInputValue, {
            inputValue
          });
        }),
        onBlur: props.onBlur ? () => {
          const event = {
            target: {
              id: props.id,
              name: (() => {
                if (!props.name) return undefined;
                if (!props.isMulti) return props.name;
                // We append the ".0" to make Formik set the touched
                // state as an array instead of a boolean only.
                // Otherwise the shapes would clash on submission, as
                // Formik will create an array on submission anyways.
                return `${props.name}.0`;
              })()
            },
            persist: () => {}
          };
          props.onBlur && props.onBlur(event);
        } : undefined,
        onChange: (value, info) => {
          // wrapping breaking changes made in react-select v3
          let newValue = value;
          if (props.isMulti && !newValue) {
            newValue = [];
          }
          props.onChange?.({
            target: {
              id: props.id,
              name: props.name,
              value: newValue
            },
            persist: () => {}
          }, info);
        },
        onFocus: props.onFocus,
        onInputChange: props.onInputChange,
        placeholder: placeholder,
        tabIndex: props.tabIndex,
        tabSelectsValue: props.tabSelectsValue,
        value: value
        // Async react-select props
        ,
        defaultOptions: props.defaultOptions,
        loadOptions: props.loadOptions,
        cacheOptions: props.cacheOptions
        // Creatable props
        ,
        allowCreateWhileLoading: props.allowCreateWhileLoading,
        formatCreateLabel: props.formatCreateLabel || (inputValue => intl.formatMessage(selectUtils.messages.createLabel, {
          inputValue
        })),
        isValidNewOption: props.isValidNewOption,
        getNewOptionData: props.getNewOptionData,
        onCreateOption: props.onCreateOption,
        createOptionPosition: props.createOptionPosition
        // @ts-ignore
        ,
        iconLeft: props.iconLeft,
        isCondensed: props.isCondensed
      })
    }))
  });
};
AsyncCreatableSelectInput.displayName = 'AsyncCreatableSelectInput';

/**
 * Expose static helper methods.
 */

// Formik will set the field to an array on submission, so we always have to
// deal with an array. The touched state ends up being an empty array in case
// values were removed only. So we have to treat any array we receive as
// a signal of the field having been touched.
AsyncCreatableSelectInput.isTouched = touched => Boolean(touched);

/**
 * Expose react-select components for customization purposes.
 */

// custom
AsyncCreatableSelectInput.ClearIndicator = customizedComponents.ClearIndicator;
AsyncCreatableSelectInput.Control = reactSelect.components.Control;
//https://github.com/commercetools/ui-kit/pull/3054/files#r1943026570
AsyncCreatableSelectInput.CrossIcon = reactSelect.components.CrossIcon;
//https://github.com/commercetools/ui-kit/pull/3054/files#r1943026570
AsyncCreatableSelectInput.DownChevron = reactSelect.components.DownChevron;
// custom
AsyncCreatableSelectInput.DropdownIndicator = customizedComponents.DropdownIndicator;
AsyncCreatableSelectInput.Group = reactSelect.components.Group;
AsyncCreatableSelectInput.GroupHeading = reactSelect.components.GroupHeading;
AsyncCreatableSelectInput.IndicatorSeparator = reactSelect.components.IndicatorSeparator;
AsyncCreatableSelectInput.IndicatorsContainer = reactSelect.components.IndicatorsContainer;
AsyncCreatableSelectInput.Input = reactSelect.components.Input;
// custom
AsyncCreatableSelectInput.LoadingIndicator = customizedComponents.LoadingIndicator;
AsyncCreatableSelectInput.LoadingMessage = reactSelect.components.LoadingMessage;
AsyncCreatableSelectInput.Menu = reactSelect.components.Menu;
AsyncCreatableSelectInput.MenuList = reactSelect.components.MenuList;
//https://github.com/commercetools/ui-kit/pull/3054/files#r1943026570
AsyncCreatableSelectInput.MenuPortal = reactSelect.components.MenuPortal;
AsyncCreatableSelectInput.MultiValue = reactSelect.components.MultiValue;
AsyncCreatableSelectInput.MultiValueContainer = reactSelect.components.MultiValueContainer;
AsyncCreatableSelectInput.MultiValueLabel = reactSelect.components.MultiValueLabel;
// custom
AsyncCreatableSelectInput.MultiValueRemove = customizedComponents.MultiValueRemove;
AsyncCreatableSelectInput.NoOptionsMessage = reactSelect.components.NoOptionsMessage;
AsyncCreatableSelectInput.Option = reactSelect.components.Option;
AsyncCreatableSelectInput.Placeholder = reactSelect.components.Placeholder;
AsyncCreatableSelectInput.SelectContainer = reactSelect.components.SelectContainer;
AsyncCreatableSelectInput.SingleValue = reactSelect.components.SingleValue;
AsyncCreatableSelectInput.ValueContainer = reactSelect.components.ValueContainer;
var AsyncCreatableSelectInput$1 = AsyncCreatableSelectInput;

// NOTE: This string will be replaced on build time with the package version.
var version = "20.2.2";

exports["default"] = AsyncCreatableSelectInput$1;
exports.version = version;
